#include <stdlib.h>
#include <direct.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>

#include <pr.h>

#if defined (MSGLIDE) || defined (WTGLIDE)
 #include <glide.h>
 #include <pr3dfx.h>
 #include "winutil.h"
 #include <windows.h>
#elif defined (WIN32)
 #include "winutil.h"
 #include <windows.h>
#else
 #ifdef __3DFX__
  #include <pr3dfx.h>
  #include <glide.h>
 #endif
#endif

#include <prgui.h>

#include <prdev.h>

/*

MakeSPR Utility

Creates a sprite PRO file from a texture

 This is useful for creating sprites that can be used with the scnedit
 utility.  Note that you can also use joinpro to create multilayered
 sprites.

 
 Revision History:
 June 2, 1998: Created

*/

char outfile[80];               /* Name of the output file */
PR_OBJECT *object;             /* Output object */
PR_DWORD choice;


void main (int argc, char *argv[])
{
PR_MATERIAL m;
PR_DWORD texnum, matnum;
PR_REAL scale;
PR_DWORD i;

  PRGUI_InitPath (argv[0]);

  printf ("MAKESPR Utility    version ");
  printf (PR_VERSION_NUMBER);
  printf ("\nCopyright 1998 Egerter Software\n\n");

  if (argc < 4)
    {
     printf ("Usage: \n"
             "MAKESPR texture.ext outfile.PRO scale\n"
             "ext = [PCX, 3DF, IFF, BLK, PAK]\n");
	 
     #ifdef WIN32
	 PR_FatalError ("Usage: \n"
                     "MAKESPR texture.ext outfile.PRO\n"
                     "ext = [PCX, 3DF, IFF, BLK, PAK]\n",
                                        "MakeSPR");
     #endif
     exit (1);
    }

  if (PRGUI_FileExists (argv[2]))
    {
     #ifdef WIN32
       if (MessageBox(NULL, "The file already exists! Overwrite?\n",
                  "MakeSPR", MB_OKCANCEL) != IDOK)
                  exit (1);
     #else
       printf ("%s already exists! Overwrite? (Y/N)\n", argv[2]);
       do {
         choice = toupper (getch ());
       } while (choice != 'N' && choice != 'Y');

       if (choice == 'N')
         exit (1);
     #endif
    }

  scale = atof (argv[3]);

  ChooseDeviceSoftware ();
  
  PR_Initialize (50);
  InitializeDevices ();

  PR_AllocMaterials (512);
  PR_AllocTextures (255);
  PR_AllocShadeTables (32);

  texnum = PR_LoadTexture (argv[1]);
  if (texnum < 0)
    PR_FatalError ("An error has occurred when loading the texture file.", "MakeSPR");

  PR_SetMaterialMethod (&m, T_LIGHTMAP_ADD);
  PR_SetMaterialColor (&m, 255, 255, 255);
  PR_SetMaterialShades (&m, 31);
  PR_SetMaterialEnvironmentMap (&m, 0);
  PR_SetMaterialMipMapState (&m, FALSE);
  PR_SetMaterialAlpha (&m, 255);

  PR_SetMaterialName (&m, argv[1]);
  PR_SetMaterialTexture (&m, texnum);

  matnum = PR_AddMaterial (&m);
  if (matnum < 0)
    PR_FatalError ("An error has occurred when creating the material.", "MakeSPR");

  object = PR_AllocSprite (matnum);

  for (i = 1; i < 5; i++)
    {
     object->segment_list->vertex_list[i].x *= scale;
     object->segment_list->vertex_list[i].y *= scale;
    }

  PR_SavePRO (argv[2], object, SAVE_ALL_MATERIALS);

  #ifndef WIN32
   wsetmode (3);                        /* Go back to text mode */
  #endif
}



