#include <math.h>
#include <malloc.h>
#include <stdlib.h>
#include <direct.h>
#include <string.h>
#include <conio.h>

#include <pr.h>
#include "mdl.h"

#if defined (MSGLIDE) || defined (WTGLIDE)
 #include <glide.h>
 #include <pr3dfx.h>
 #include "winutil.h"

#elif defined (MSDD) || defined (WTDD) || defined (MSGL) || defined (WTGL)
 #include "winutil.h"
#else
 #ifdef __3DFX__
  #include <pr3dfx.h>
  #include <glide.h>
 #endif

 #ifdef __MYST__
  #include <msidos.h>
  #include <prmyst.h>
 #endif

#endif

#include <prgui.h>
#include <prdev.h>


PR_DWORD     current_mode;          /* Current video mode */
PR_DWORD     vwidth;                /* Viewport size */
PR_DWORD     vheight;
PR_DWORD     view_opened = 0;       /* 0 for first initialization */
PR_VIEWPORT  viewport;              /* Our viewport structure */
PR_LIGHTLIST userlights;            /* We only use 1 light */
PR_CAMERA *  animcam;               /* Camera used for animation */
PR_CAMERA *  usercam;               /* Movable Camera */
PR_REAL      scale = 1.0f;          /* Scale multiplier for 3DS or LWO models */   
PR_REAL      dx, dy, dz;            /* Delta rotation */
PR_REAL      speeddiv = 150;        /* Speed divisor */

PR_OBJECT *  test;                  /* The shape loaded */
PR_ENTITY *  obj1;                  /* A single entity of the shape */
PR_DWORD     frame = 1;             /* Current frame of the animation */





PR_DWORD maxframe;


#define FLAT_MODE 0
#define GOURAUD_MODE 1

#define ANIMATION_MODE 0
#define INSPECTION_MODE 1

#define ANIMATION_CAMERA 0
#define USER_CAMERA 1

/* Toggles */
PR_DWORD     force_vga = 0;
PR_DWORD     ignore_camera = 0;
PR_DWORD     ignore_animation = 0;
PR_DWORD     flip_delay = 0;
PR_DWORD     anim_play = 1;
PR_DWORD     mdl_mode = 0;
PR_DWORD     shade_mode = FLAT_MODE;
PR_DWORD     control_mode = ANIMATION_MODE;
PR_DWORD     camera_mode = ANIMATION_CAMERA;


/* Quake Model Variables */
char         pakfile[80];           /* PAK file for Quake models */
char         pcxfile[80];           /* Skin for Quake2 models */
extern PR_VERTEX *frame_list[256];  /* Holds each frame of morphed animation */
extern mdl_t  *testmdl;             /* Quake1 model structure */
extern mdl_t2 *testmd2;             /* Quake2 model structure */

/* User Interface */
PR_DWORD     ControlTex[10];        /* Texture numbers for VCR buttons */
PR_DWORD     CursorTex;             /* Texture number of the cursor */
PR_DWORD     Grey1, Grey2, Grey3;   /* Three shades of grey */
color        controlpal[256];       /* Palette for the user interface */
PR_DWORD     brightcolor;           /* Bright foreground text color */
PR_DWORD     darkcolor;             /* Dark background text color */
PR_DWORD     sky_color;             /* Rendered image background color */
PR_REAL      ambient_light = 0;
PR_REAL      gamma_correction = 1.3;

/* Frame Rate Control  */
PR_DWORD ticks;                     /* Total number of ticks passed */
PR_DWORD updates;                   /* Total number of updates */
PR_DWORD framerate;                 /* Resulting frame rate (updates/ticks/tickrate) */



/* Screen capture */
typedef struct {
  char idlength;
  char colormaptype;
  char imagetype;
  unsigned short colormapstart;
  unsigned short colormaplength;
  char colormapbits;
  unsigned short xstart, ystart, width, depth;
  char bits;
  char descriptor;
} PR_TGAHEADER;
PR_TGAHEADER tga;



void DumpScreenshot (void)
/* Saves a TGA screenshot.  Shots are automatically numbered */
{
block pic;
FILE *out;
unsigned short *temp;
PR_UWORD rgb;
PR_DWORD l;
PR_DWORD r, g, b;
char outfile[80];
PR_DWORD number;


  number = 1;
  for (;;)
   {
    sprintf (outfile, "screen%i.tga", number);
    out = fopen (outfile, "rb");
    if (out == NULL)
      break;
    number++;
    fclose (out);
   }

  pic = PRGFX_NewBlock (0, 0, 639, 479);
  temp = (unsigned short *)pic;

  memset ((char *)&tga, 0, sizeof (PR_TGAHEADER));
  tga.descriptor = 0x20;
  tga.width = 640;
  tga.depth = 480;
  tga.idlength = 0;
  tga.imagetype = 2;
  tga.bits = 24;

  sprintf (outfile, "screen%i.tga", number);
  out = fopen (outfile, "wb");
  fwrite (&tga, sizeof (PR_TGAHEADER), 1, out);

  for (l = 0; l < 640*480; l++)
    {
     rgb = *temp++;

     r = (rgb >> 11);
     g = (rgb - (r << 11)) >> 5;
     b = (rgb - (r << 11) - (g << 5));

     fputc (b << 3, out);
     fputc (g << 2, out);
     fputc (r << 3, out);
    }

  fclose (out);

  free (pic);
}



void LoadControls (void)
/* Load the VCR button images, font, and mouse cursor */
{
  PRGUI_GoStartPath ();
  setlib ("guidata.prl");

  gui_font = wloadfont ("prview.wfn");

  if (PR_OutputDevice.bitdepth <= 8)
    {
     quantize_textures = 1;
     PR_Settings.LoadPalette = 0;
    }
  else
    PR_Settings.LoadPalette = 1;

  PR_SetTextureFormat (TEXTURE_NORMAL);
  ControlTex[0] = PR_LoadTexture ("cont1.pcx");
  ControlTex[1] = PR_LoadTexture ("cont2.pcx");
  ControlTex[2] = PR_LoadTexture ("cont3.pcx");
  ControlTex[3] = PR_LoadTexture ("cont4.pcx");
  ControlTex[4] = PR_LoadTexture ("cont5.pcx");
  ControlTex[5] = PR_LoadTexture ("cont6.pcx");
  ControlTex[6] = PR_LoadTexture ("cont7.pcx");
  ControlTex[7] = PR_LoadTexture ("cont8.pcx");
  ControlTex[8] = PR_LoadTexture ("cont9.pcx");

  PR_SetTextureFormat (TEXTURE_XRAY);
  CursorTex = PR_LoadTexture ("cursor.pcx");

  Grey1 = PRGFX_MakeColor (38, 38, 38);
  Grey2 = PRGFX_MakeColor (52, 52, 52);
  Grey3 = PRGFX_MakeColor (30, 30, 30);
  memcpy (controlpal, global_palette, 768);

  setlib (NULL);
  PRGUI_GoUserPath ();
}


PR_DWORD ComputeFrameToSlider (void)
/* Return the frame number given the position of the slider */
{
PR_REAL t;   /* Animation time */
PR_REAL len; /* Length of slider area */

  t = (PR_REAL)frame / (PR_REAL)maxframe;
  len = (vwidth - 8.0f) - 133.0f;

  return (133 + len * t);
}


void ComputeSliderToFrame (void)
/* Return the slider position given the frame number */
{
PR_REAL len; /* Length of slider area */

  len = (vwidth - 8.0f) - 133.0f;
  frame = (mouse.mx - 133) / len * (PR_REAL)maxframe;

  if (frame > maxframe-1)
    frame = maxframe-1;
}


void DisplayControls (void)
{
  PRGFX_Clip (0, 0, vwidth-1, vheight-1);
 
  PRGFX_SetColor (Grey2);

  PR_SetConstantZ (1);

  PRGFX_Bar (0, 0, vwidth-1, 17);


  PRGFX_SetColor (Grey3);
  PRGFX_HLine (133, vwidth - 8, 8);
  PRGFX_SetColor (Grey1);

  PRGFX_SetTextForeground (Grey1);
  PRGFX_SetTextBackground (Grey2);
  PRGFX_SetTextTransparent (TEXTFGBG);
  PRGFX_Clip (0, 0, vwidth-1, vheight-1);

  if (maxframe > 0)
   PRGUI_printf ((vwidth - 8 - 133) / 2 + 133, 4, "%i", frame);

  if (device == DEVICE_D3D)
    PR_NewFrame ();
  PRGFX_PutTexture (2,   1, ControlTex[0], NORMAL);
  PRGFX_PutTexture (20,  1, ControlTex[1], NORMAL);
  PRGFX_PutTexture (38,  1, ControlTex[2], NORMAL);
  PRGFX_PutTexture (56,  1, ControlTex[3], NORMAL);
  PRGFX_PutTexture (74,  1, ControlTex[4], NORMAL);
  PRGFX_PutTexture (92,  1, ControlTex[5], NORMAL);
  PRGFX_PutTexture (110, 1, ControlTex[6], NORMAL);

  if (maxframe > 0)
     PRGFX_PutTexture (ComputeFrameToSlider(), 2, ControlTex[7], NORMAL);

  if (control_mode == ANIMATION_MODE)
    PRGFX_PutTexture (mouse.mx, mouse.my, CursorTex, XRAY);

  if (device == DEVICE_D3D)
    PR_RenderFrame ();
}



void DisplayHelp (void)
{
  PRGFX_SetTextForeground (brightcolor);
  PRGFX_SetTextTransparent (TEXTFG);
  PRGFX_SetColor (brightcolor);

  PRGUI_printf (0, 20, "PRView Pro (BUILD 2.5c)");
  PRGUI_printf (0, 30, "Copyright 1998 Egerter Software");
  PRGUI_printf (0, 40, "Visit http://www.egerter.com");

  PRGUI_printf (0, 60, "Click on the slider to move quickly");
  PRGUI_printf (0, 70, "through the animation.");
  PRGUI_printf (0, 80, "Spacebar  : Toggles between VCR and");
  PRGUI_printf (0, 90, "            Inspect mode (hidden cursor)");
  PRGUI_printf (0, 100, "TAB       : Cycles through SVGA modes");
  PRGUI_printf (0, 110, "ESC       : Quits");

  PRGUI_printf (0, 130, "Inspection Mode:");
  PRGUI_printf (0, 140, "Move mouse: Tilt camera");
  PRGUI_printf (0, 150, "A         : Move camera forward");
  PRGUI_printf (0, 160, "Z         : Move camera backward");
  PRGUI_printf (0, 170, "C         : Toggle animation/user camera");
  PRGUI_printf (0, 180, "Press F2 for more help");
}


void DisplayHelp2 (void)
{
  PRGFX_SetTextForeground (brightcolor);
  PRGFX_SetTextTransparent (TEXTFG);
  PRGFX_SetColor (brightcolor);

  PRGUI_printf (0, 20, "PRView Pro (BUILD 2.5c)");
  PRGUI_printf (0, 30, "Copyright 1998 Egerter Software");
  PRGUI_printf (0, 40, "Visit http://www.egerter.com");

  PRGUI_printf (0, 60, "+ (keypad): Increase movement speed");
  PRGUI_printf (0, 70, "- (keypad): Decrease movement speed");
  PRGUI_printf (0, 80, "LMB + move: Spins around x/y axis");
  PRGUI_printf (0, 90, "RMB + move: Spins around z axis");
  PRGUI_printf (0, 100, "MB + release: Auto-spin mode");
  PRGUI_printf (0, 120, ",         : Decrease Ambient light");
  PRGUI_printf (0, 130, ".         : Increase Ambient light");
  PRGUI_printf (0, 140, ";         : Decrease Gamma (3Dfx only)");
  PRGUI_printf (0, 150, "\"         : Increase Gamma (3Dfx only)");
}







/* ---------------------------------------------------------------------- */
/* Timer Interrupt */
/* ---------------------------------------------------------------------- */
void timerproc (void)
{
  ticks++;
}                


/* ---------------------------------------------------------------------- */
/* Cycles through 3 video modes (320x200, 640x480, 800x600) */
/* ---------------------------------------------------------------------- */
PR_DWORD SetVideoMode (void)
{
  /* Cycle through all the modes */

  do {
   current_mode++;
   if (PR_VideoModes[current_mode].mode_number == -1)
     current_mode = 0;
   } while ((PR_VideoModes[current_mode].pages < 1) && (force_vga == 0));

  vwidth = PR_VideoModes[current_mode].width;
  vheight = PR_VideoModes[current_mode].height;

  PR_SetMode (vwidth, vheight, 60);

  if (view_opened)
    PR_CloseViewport (&viewport);

  PR_OpenViewport (&viewport, 0, 0, vwidth-1, vheight-1, VIEW_PLAIN);

  PR_SetViewport (&viewport);
  PRGFX_Clip (active_viewport.topx,
              active_viewport.topy,
              active_viewport.bottomx,
              active_viewport.bottomy);
  view_opened = 1;

#if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
  if ((device == DEVICE_VGA) || (device == DEVICE_SVGA))
    wsetpalette (0, 255, global_palette);
#endif

  return (1);
}


void DoNothing (void)
/* Watcom likes to get stuck in an endless loop because it doesn't
   know the kbdon array can change. */
{
PR_DWORD dummy = 0;
  dummy++;
}


/* ---------------------------------------------------------------------- */
/* Move the camera and rotate the object based on the user input */
/* ---------------------------------------------------------------------- */
void UserInput (void)
{

  if (control_mode == INSPECTION_MODE)
    PR_ReadInput ();              

  /* This uses the inspect model.  Below we have some additional input
     controls */

  PR_CameraDirection (usercam);
  PR_DollyCamera (usercam, currentspeed);

  if (control_mode == ANIMATION_MODE)
    {
     if (mouse.but == 1)
       {
        if ((mouse.mx > 133) && (mouse.mx < vwidth-8) && (mouse.my < 16))
          ComputeSliderToFrame ();

        if (PRGUI_HitButton (2, 0, 18, 18))
          anim_play = 1;
        else if (PRGUI_HitButton (20, 0, 36, 18))
          anim_play = 0;
        else if (PRGUI_HitButton (38, 0, 54, 18))
          {
           anim_play = 0;
           frame = 1;
          }
        else if (PRGUI_HitButton (56, 0, 72, 18))
          frame = 1;
        else if (PRGUI_HitButton (74, 0, 90, 18))
          {
           if (frame > 1)
             frame--;
          }
        else if (PRGUI_HitButton (92, 0, 108, 18))
          {
           if ((maxframe > 0) &&
               (frame < maxframe - 1))
             frame++;
          }
        else if (PRGUI_HitButton (110, 0, 126, 18))
          {
           if (maxframe > 0)
             frame = maxframe-1;
          }
       }
     
    }
  else
    {
     /* Object Rotation */
     if (mouse.but == 1)
       {
        dx = (PR_REAL)(mouse.my - 100) / 5;
        dy = (PR_REAL)(mouse.mx - 160) / 5;
        msetxy (160, 100);
       }
     else if (mouse.but == 2)
       {
        dz = (PR_REAL)(mouse.mx - 160) / 5;
        msetxy (160, 100);
       }
     msetxy (160, 100);
     mouse.mx = 160;
     mouse.my = 100;
    }

  if (kbdon[KEY_F10])
    DumpScreenshot ();


  /* Keyboard input */
  if (kbdon[KEY_TAB])
    {
     if (device == DEVICE_SVGA)
       while (!SetVideoMode ());
     while (kbdon[KEY_TAB]) 
       { 
        DoNothing ();
        #ifdef WIN32
          UpdateMessages ();
        #endif
       }           /* Wait for user to release key */
    }


  if (kbdon[KEY_SPACE])
    {
     control_mode = !control_mode;
     msetxy (160, 100);
     while (kbdon[KEY_SPACE]) 
       { 
        DoNothing ();
        #ifdef WIN32
          UpdateMessages ();
        #endif
       }           /* Wait for user to release key */
    }


  if (kbdon[KEY_C])
    {
     camera_mode = !camera_mode;

     if ((camera_mode == USER_CAMERA) && (animcam != NULL))
       {
        usercam->source.x = animcam->source.x;
        usercam->source.y = animcam->source.y;
        usercam->source.z = animcam->source.z;
       }

     msetxy (160, 100);
     while (kbdon[KEY_C]) 
       { 
        DoNothing ();
        #ifdef WIN32
          UpdateMessages ();
        #endif
       }           /* Wait for user to release key */
    }


  /* Change ambient lighting */
  if (kbdon[KEY_COMMA])
    {
     ambient_light -= 0.1;
     if (ambient_light < 0.0)
       ambient_light = 0;

     PR_SetAmbientLight (ambient_light);
     PR_AmbientRed   = ambient_light * 255;
     PR_AmbientGreen = ambient_light * 255;
     PR_AmbientBlue  = ambient_light * 255;
    }

  if (kbdon[KEY_DOT])
    {
     ambient_light += 0.1;
     if (ambient_light > 1)
       ambient_light = 1;

     PR_SetAmbientLight (ambient_light);
     PR_AmbientRed   = ambient_light * 255;
     PR_AmbientGreen = ambient_light * 255;
     PR_AmbientBlue  = ambient_light * 255;
    }


  /* Change gamma correction (3Dfx only) */
  if (device == DEVICE_3DFX)
  {
  if (kbdon[KEY_SEMICOLON])
    {
     gamma_correction -= 0.05;
     if (gamma_correction < 0.0)
       gamma_correction = 0;

     #ifdef __3DFX__
     grGammaCorrectionValue (gamma_correction);
     #endif
    }

  if (kbdon[KEY_DQUOTE])
    {
     gamma_correction += 0.05;
     if (gamma_correction > 2.5)
       gamma_correction = 2.5;

     #ifdef __3DFX__
     grGammaCorrectionValue (gamma_correction);
     #endif
    }
   }



  /* Change movement speed */
  if (kbdon[KEY_GREY_MINUS])
    {
     speeddiv += 5;
     TRANSLATE_SPEED    = test->bbox.radius / (speeddiv*10);
     MAX_TRANSLATE_SPEED= test->bbox.radius / speeddiv;
     TRANSLATE_DRAG     = test->bbox.radius / (speeddiv*5);
    }
  else if (kbdon[KEY_GREY_PLUS])
    {
     speeddiv -= 5;
     if (speeddiv < 2)
       speeddiv = 1;
     TRANSLATE_SPEED    = test->bbox.radius / (speeddiv*10);
     MAX_TRANSLATE_SPEED= test->bbox.radius / speeddiv;
     TRANSLATE_DRAG     = test->bbox.radius / (speeddiv*5);
    }
}



/* ---------------------------------------------------------------------- */
/* Initialize Power Render and allocate room for data */
/* ---------------------------------------------------------------------- */
void InitializeProgram (void)
{
  PR_AllocMaterials (512);
  PR_AllocTextures (256);
  PR_AllocShadeTables (32);
}



/* ---------------------------------------------------------------------- */
/* Make one light which will follow the camera */
/* ---------------------------------------------------------------------- */
void InitializeLights (void)
{
  /* Initialize the lights */
  PR_AllocLights (&userlights, 1);      /* User lights */
  PR_AllocLights (&scenelights, 1);     /* Master scene light list */

  PR_SetLightPosition (&userlights, 0, 0, 0, 10000);
  /* Doesn't matter because we set it to the camera location every frame */

  PR_SetLightOn (&userlights, 0);
  PR_SetLightType (&userlights, 0, DIRECTIONAL_LIGHT);
  PR_SetLightStrength (&userlights, 0, 1.0);
  PR_SetLightColor (&userlights, 0, 1.0, 1.0, 1.0);

  userlights.NumLights = 1;     /* This sets how many lights are actually used */
}



void Fix_EnvMap (PR_OBJECT *obj)
{
PR_SEGMENT *segptr;
PR_MATERIAL *matptr;
PR_FACE *faceptr;
PR_DWORD seg, face;
  
  for (seg = 0; seg < obj->num_segments; seg++)
    { /* For every segment */

     segptr = &obj->segment_list[seg];
     segptr->flags &= ~FLAG_NORMALS;    /* Clear out the normals flag */

     for (face = 0; face < segptr->num_faces; face++)
       { /* For every face */

        faceptr = &segptr->face_list[face];
        matptr = &PR_ObjectMaterialList[faceptr->material];


        if (matptr->environment_map)
          segptr->flags |= FLAG_NORMALS;

        matptr = &PR_ObjectMaterialList[faceptr->backmaterial];
        if (matptr->environment_map)
          segptr->flags |= FLAG_NORMALS;
       }
    }

}



/* ---------------------------------------------------------------------- */
/* Loads a 3DS LWO, or PRO file */
/* ---------------------------------------------------------------------- */
void LoadFile (char *filename, PR_DWORD loadmode)
{
char path[_MAX_PATH];
#if defined (WIN32)
char drive[_MAX_DRIVE],dir[_MAX_DIR],name[_MAX_FNAME],ext[_MAX_EXT];
#else
char drive[_MAX_DRIVE],dir[_MAX_DIR],name[_MAX_NAME],ext[_MAX_EXT];
#endif

  strupr (filename);
  _makepath (path, drive, dir, filename,"");
  _splitpath (path, drive, dir, name, ext);

  if (!strcmp(ext,".3DS"))
    {
     PR_BaseMaterialNumber = 0;
     test = PR_Load3DS (filename, scale, loadmode);

     PR_Settings.FrontToBack = 0;
     if (test == NULL)
       {
                #ifndef WIN32
                  wsetmode (3);
                #endif

                PR_FatalError ("Could not open the 3DS file", "PRVIEW");
       }

     if (loadmode == LOAD_IGNORE_TEXTURES)
       PR_CreateMaterialPalette ();
#if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
     if ((device == DEVICE_VGA) || (device == DEVICE_SVGA))
        wsetpalette (0, 255, global_palette);
#endif
     PR_SetObjectFaceFlags (test, FFLAG_FRONT_VISIBLE, FLAG_SET);
     PR_InitializeFaceNormals (test);
     PR_InitializeVertexNormals (test);
     Fix_EnvMap (test);
    }
  else if (!strcmp(ext,".LWO"))
    {
     PR_BaseMaterialNumber = 0;
     test = PR_LoadLWO (filename, scale, loadmode);

     PR_Settings.FrontToBack = 0;
     if (test == NULL)
       {
                #ifndef WIN32
                  wsetmode (3);
                #endif

                PR_FatalError ("Could not open the LWO file", "PRVIEW");
       }

     if (loadmode == LOAD_IGNORE_TEXTURES)
       PR_CreateMaterialPalette ();
    #if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
    if ((device == DEVICE_VGA) || (device == DEVICE_SVGA))
       wsetpalette (0, 255, global_palette);
    #endif
     PR_InitializeFaceNormals (test);
     PR_InitializeVertexNormals (test);
     Fix_EnvMap (test);
    }
  else if (!strcmp(ext,".PRO"))
    {
     test = (PR_OBJECT *)PR_LoadPRO (filename, LOAD_NORMAL);

     PR_Settings.FrontToBack = 0;
     if (test == NULL)
       {
                #ifndef WIN32
                  wsetmode (3);
                #endif

                PR_FatalError ("Could not open the PRO file", "PRVIEW");
       }
     
     #if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
       if ((device == DEVICE_VGA) || (device == DEVICE_SVGA))
         wsetpalette (0, 255, global_palette);
     #endif
    }
  else if (!strcmp(ext,".MDL"))
    {
     if (pakfile[0]==0)
       testmdl = PR_LoadMDLFromPak (filename, NULL);
     else
       testmdl = PR_LoadMDLFromPak (filename, pakfile);
     test = PR_ImportMDL (testmdl);

     PR_Settings.FrontToBack = 0;
     if (test == NULL)
       {
                #ifndef WIN32
                  wsetmode (3);
                #endif

                PR_FatalError ("Could not open the MDL file", "PRVIEW");
       }

     #if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
       if ((device == DEVICE_VGA) || (device == DEVICE_SVGA))
         wsetpalette (0, 255, global_palette);
     #endif

     FixMDLNormals (testmdl->numframes);
     mdl_mode = 1;
    }
  else if (!strcmp(ext,".MD2"))
    {
     if (pakfile[0]==0)
       testmd2 = PR_LoadMD2FromPak (filename, NULL);
     else
       testmd2 = PR_LoadMD2FromPak (filename, pakfile);
     test = PR_ImportMD2 (testmd2);

     PR_Settings.FrontToBack = 0;
     if (test == NULL)
       {
                #ifndef WIN32
                  wsetmode (3);
                #endif

                PR_FatalError ("Could not open the MD2 file", "PRVIEW");
       }

     #if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
       if ((device == DEVICE_VGA) || (device == DEVICE_SVGA))
         wsetpalette (0, 255, global_palette);
     #endif

     FixMDLNormals (testmd2->numframes);
     mdl_mode = 2;
    }
   else
     {
      #ifndef WIN32
           wsetmode (3);
          #endif

          PR_FatalError ("Unknown file format", "PRVIEW");
     }

  obj1 = PR_CreateEntity (test, "OBJ1");
  PR_ScaleEntityAbs (obj1, 1, 1, 1);
}


void UpdateAnimation (void)
{
PR_DWORD previous_frame, frame_number;
PR_REAL morphvalue = 0;

  if (!ignore_animation)
    {
     if (mdl_mode)
       {
        if (anim_play)
          frame++;
        if (frame >= maxframe)
          frame = 0;

        morphvalue = (frame % 10) / 10.0f;
        previous_frame = frame / 10;
        frame_number = previous_frame + 1;

        if ((mdl_mode == 1) && (frame_number >= testmdl->numframes))
          frame_number--;
        if ((mdl_mode == 2) && (frame_number >= testmd2->numframes))
          frame_number--;
        PR_MorphWithNormals (frame_list[previous_frame],
                             frame_list[frame_number],
                             test->segment_list->vertex_list,
                             test->segment_list->num_vertices, morphvalue);
       }
     else if (maxframe > 0)
       {
        if (anim_play)
          frame++;
        if (frame >= maxframe)
          frame = 0;
        PR_AnimateEntity (obj1, frame);
       }

     if ((camera_mode == ANIMATION_CAMERA) && (animcam != NULL))
       {
        if (animcam->num_frames > 0)
          {
           if (frame >= animcam->num_frames)
             frame = 0;
           if (!ignore_camera)
             PR_AnimateCamera (animcam, frame);
          }
       }
    }
}




void DisplayFrame (void)
{
  PR_OpenScreen (PR_BACKBUFFER);
          
  PRGFX_SetColor (sky_color);
  PRGFX_Clip (active_viewport.topx,
              active_viewport.topy + 18,        /* Leave room for the VCR controls */
              active_viewport.bottomx,
              active_viewport.bottomy);

  #if !defined (MSGLIDE) && !defined (WTGLIDE)  && !defined (MSGL) && !defined (WTGL)
  if (PR_Settings.FrontToBack && device != DEVICE_3DFX)
    PR_ResetHoles ();
  else
  #endif
  PR_ClearViewport (&viewport);

  PR_NewFrame ();                         /* Begin a new frame */

  UpdateAnimation ();

  /* Set the active camera once the animation is done.  We could have a
     keyframed camera */
  if ((camera_mode == ANIMATION_CAMERA) && (animcam != NULL))
    PR_SetActiveCamera (animcam);
  else
    PR_SetActiveCamera (usercam);


  PR_SetLightPosition (&userlights, 0,
                        PR_CurrentCamera->source.x,
                        PR_CurrentCamera->source.y,
                        PR_CurrentCamera->source.z);
  PR_TransformLights (&userlights);

  /* Rotate the model if the mouse was clicked and dragged */
  PR_RotateEntity (obj1, dx, dy, dz);

  PRGFX_SetColor (PRGFX_MakeColor (63, 0, 0));
  PR_TransformEntity (obj1);
  PR_RenderEntity (obj1);

  PR_RenderFrame ();

  if (device != DEVICE_3DFX)
    {
     /* If we are using front to back, we have to fill the empty
        spans with a color */
     #if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
     if (PR_Settings.FrontToBack)
       PR_FillHoles (PR_BackgroundColor);
     #endif
    }

  /* Calculate the frame rate */
  if (ticks > 60)
    {
     framerate = updates;
     ticks = 0;
     updates = 0;
    }
  else
    updates++; 

  PRGFX_SetTextForeground (brightcolor);
  PRGFX_SetTextBackground (darkcolor);
  PRGFX_SetTextTransparent (TEXTFGBG);
  PRGUI_printf (5, vheight - 11, "%i", framerate);
  /* Now the model is drawn, so just draw the VCR controls over it */
  DisplayControls ();

  if (kbdon[KEY_F1])
    DisplayHelp ();
  if (kbdon[KEY_F2])
    DisplayHelp2 ();

  PR_Flip (flip_delay);
}





/* ---------------------------------------------------------------------- */
/* Main program */
/* ---------------------------------------------------------------------- */
void main (int argc, char *argv[])
{
PR_DWORD argnum;
PR_DWORD loadmode = 0;

  loadmode = LOAD_IGNORE_TEXTURES;

  PRGUI_InitPath (argv[0]);
  PRGUI_SetUserPath ();

  printf ("PRVIEW PRO Utility    version 2.5c\n");
  printf ("Copyright 1997 Egerter Software\n\n");

  if (argc < 2)
    {
         PR_FatalError ("Usage: \n"
             "PRVIEW filename.[PRO/3DS/MDL/MD2/LWO] [options]\n"
             "\n"
             "Options:\n"
             "-s scale      Changes scaling factor for 3DS and LWO files\n"
             "-nocam        Ignores any camera stored in the file\n"
             "-noanim       Ignores any animation stored in the file\n"
             "-t ext        Imports textures from 3DS or LWO, using extension\n"
             "              ext = [PCX, 3DF, IFF, BLK, PAK]\n"
             "-m pakfile    Specifies a PAK file (ie pak1.pak)\n"
             "              If none specified, it loads from the file directly\n"
             "-g            Uses Gouraud shading for Quake models\n"
             "-p file.pcx   Uses file.pcx for a Quake2 Skin (for player models)\n"
             "-svga         Uses SVGA mode instead of VGA\n", "PRVIEW");
    }


  /* Default pak file */
  pakfile[0] = 0;
  force_vga = 1;

  argnum = 2;
  while (argnum < argc)
    {
     if (!strcmp (argv[argnum], "-s"))
       if (argc > argnum)
         {
          scale = atof (argv[argnum+1]);
          printf ("Scaling Factor: %f\n", scale);
          argnum++;
         }

     if (!strcmp (argv[argnum], "-svga"))
       {
        printf ("Using SVGA\n");
        force_vga = 0;
        argnum++;
       }

     if (!strcmp (argv[argnum], "-nocam"))
       {
        printf ("Ignoring keyframed cameras\n");
        ignore_camera = 1;
       }
     if (!strcmp (argv[argnum], "-noanim"))
       {
        printf ("Ignoring keyframed animation\n");
        ignore_animation = 1;
       }

     if (!strcmp (argv[argnum], "-g"))
       {
        printf ("Using Gouraud Shaded Quake Models\n");
        shade_mode = GOURAUD_MODE;
       }

     if (!strcmp (argv[argnum], "-t"))
       if (argc > argnum)
         {
          strcpy (L3DS_TextureExtension, argv[argnum+1]);
          if (strcmp (L3DS_TextureExtension, "3DF") == 0)
            device = DEVICE_3DFX;
          printf ("Textures Enabled\nTexture Extension: %s\n", L3DS_TextureExtension);
          loadmode = LOAD_NORMAL;
          argnum++;
         }

     if (!strcmp (argv[argnum], "-p"))
       if (argc > argnum)
         {
          strcpy (pcxfile, argv[argnum+1]);
          printf ("Skin PCX file: %s\n", pcxfile);
          argnum++;
         }

     if (!strcmp (argv[argnum], "-m"))
       if (argc > argnum)
         {
          strcpy (pakfile, argv[argnum+1]);
          printf ("Pak file: %s\n", pakfile);
          argnum++;
         }
     argnum++;
    }



  PRGUI_GoStartPath ();

  ChooseDevice ();

  PR_Initialize (7500);
  
#if !defined (WIN32)
  vga256 ();
  minit ();
#endif

  InitializeDevices ();
  InitializeProgram ();
  InitializeLights ();

  /* Initialize the graphics mode */
  current_mode = -1;
  while (!SetVideoMode ());

  #if defined (MSDD) || defined (WTDD) || defined (MSGL) || defined (WTGL)
   if (PR_LostSurface)
     PR_RestoreAll ();
  #endif

  if (PR_VideoModes[current_mode].pages > 1)
    flip_delay = 1;

//  PR_SetTextureFormat (TEXTURE_XRAY);
  PR_SetTextureFormat (TEXTURE_P_8);

//  PR_Settings.HardwareMipmaps = MIPMAP_ALL_LEVELS;
  PR_Settings.HardwareMipmaps = 1;


  PRGUI_GoUserPath ();
  LoadFile (argv[1], loadmode);
  LoadControls ();

  /* Get colors closest to white and black */
  PR_BackgroundColor = PRGFX_MakeColor (24, 24, 24);
  brightcolor = PRGFX_MakeColor (63, 63, 63);
  darkcolor = PRGFX_MakeColor (0, 0, 0);

  animcam = PR_GetFirstCamera ();
  if (ignore_camera)  /* Camera override */
    animcam = NULL;

  if (animcam != NULL)
    PR_AttachCameraEntity (animcam, obj1);

  /* Initialize the movable camera */
  usercam = PR_AllocCamera ();
  PR_InitializeCamera (usercam);
  PR_PositionCameraSource (usercam, 0, 0, test->bbox.radius * 2);
  usercam->rotation.y = 0;
  usercam->nearclip = 1;
//  usercam->fov = 2.0f / 3.0f * 3.1415;
  PR_SetCameraMode (usercam, CAMFLAG_ANGLE_BASED);

  /* Initialize the input devices */
  installkbd ();
  winittimer ();
  wstarttimer (timerproc, TICKS(60));
  msetxy (160, 100);
  msetbounds (0, 0, vwidth-1, vheight-1);
 
  PR_SetInputDevice (INPUT_MOUSE);
  PR_SetInputModel (MODEL_INSPECT);
  PR_SetInputEntity (NO_ENTITY, NO_SEGMENT);
  PR_SetInputCamera (usercam);

  TRANSLATE_SPEED    = test->bbox.radius / (speeddiv*10);
  MAX_TRANSLATE_SPEED= test->bbox.radius / speeddiv;
  TRANSLATE_DRAG     = test->bbox.radius / (speeddiv*5);


  /* Number of perspective texture subdivisions */
#if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
  PR_SetPerspectiveDivisions (TEXTURE_DIVISION_16);
#endif




  PR_OpenScreen (PR_BACKBUFFER);

//  PR_SetFogState (TRUE);
  PR_SetFogRange (100, 200);
//  PR_SetFogColor (sky_color);

  sky_color = PRGFX_MakeColor (0, 0, 0);

  maxframe = 0;
  if (mdl_mode == 1)
    maxframe = testmdl->numframes * 10;
  else if (mdl_mode == 2)
    maxframe = testmd2->numframes * 10;
  else if (obj1->shape->num_frames > 0)
    maxframe = obj1->shape->num_frames;


  /* main program loop */
  while (!kbdon[KEY_ESC])
    {
     #ifdef WIN32
      UpdateMessages ();
     #endif

     #if defined (MSDD) || defined (WTDD) || defined (MSGL) || defined (WTGL)
      if (PR_LostSurface)
        PR_RestoreAll ();
     #endif

     UserInput ();

     DisplayFrame ();
   }

  uninstallkbd ();
#if !defined (WIN32)
  mdeinit ();
#endif

  wstoptimer ();
  wdonetimer ();


#if !defined (WIN32)
  wsetmode (3);
#endif

}







