#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <io.h>

#include <direct.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>

#include <stdarg.h>

#include <pr.h>
//#include <prstate.h>

#if defined (MSGLIDE) || defined (WTGLIDE)
 #include <glide.h>
 #include <pr3dfx.h>
 #include "winutil.h"
 #include <windows.h>
#elif defined (WIN32)
 #include "winutil.h"
 #include <windows.h>
#else
 #ifdef __3DFX__
  #include <glide.h>
  #include <pr3dfx.h>
  #include <fxgui.h>
 #endif
#endif

#include <prgui.h>

#include <prdev.h>

/*
   scnedit 1.0
   May 1998 

*/



/* --- Defines --- */

#define DISPWIDTH 480
#define DISPHEIGHT 470

#define OBJECT_NOT_FOUND -1
#define ENTITY_LOADED 1

#define MODE_LOCATION 0
#define MODE_ROTATION 1
#define MODE_SCALE    2

/* --- Global Variables --- */

/* Variables read from the .ini file */
PR_REAL MOVEMENT_MULT=20;
PR_DWORD MaxEntities=1000;
PR_DWORD MaxObjects=500;
PR_REAL FOG_START=2000.0f;
PR_REAL FOG_END=22000.0f;

/* Strings */
char scene_name[80];                  /* Name of the scene file (.SCN) */

/* Menu Images */
block menu1;
color menu_pal[256];
PR_DWORD checktex;                    /* Texture numbers */
PR_DWORD unchecktex;

/* Colors */
PR_DWORD BLACK;
PR_DWORD TEXTCOL;
PR_DWORD DARK_GREY;
PR_DWORD WHITE;

/* Materials */
PR_DWORD point_mat;
PR_MATERIAL *white_material;

/* Cameras and Viewports */
PR_VIEWPORT viewport;
PR_CAMERA *camera;

/* Vectors */
PR_POINT UpVec;
PR_POINT ForwardVec;
PR_POINT RightVec;
PR_POINT TempVec;

/* Misc */
PR_DWORD start_screen, end_screen;
PR_DWORD mouse_savex = 0, mouse_savey = 0;
PR_DWORD flashflag = 0;                    /* Toggles between 0 and 1 */
PR_DWORD flashswitch = 0;                  /* True if flashing enabled */
PR_DWORD use_background;
PR_DWORD current_mode = 0;


typedef struct
{
 PR_UCHAR *name;
 PR_OBJECT *obj;

 PR_MATRIX lastrot;
 PR_POINT lastscale;
} ObjectType;
ObjectType *ObjectList;


typedef struct {
 PR_UCHAR active;

 PR_MATRIX rot_mat;
 PR_POINT location;
 PR_POINT scale;
 PR_UCHAR name[13];
 PR_ENTITY *ent;
} EntityType;
EntityType *EntityList;


PR_DWORD TopEntity = 0;
PR_DWORD ObjectsLoaded = 0;
PR_DWORD object_number = 0;
PR_DWORD entity_number = 0;
PR_DWORD lastobject = 0;


PR_LIGHTLIST userlights;            /* We only use 1 light */


/* Screen capture */
typedef struct {
  char idlength;
  char colormaptype;
  char imagetype;
  unsigned short colormapstart;
  unsigned short colormaplength;
  char colormapbits;
  unsigned short xstart, ystart, width, depth;
  char bits;
  char descriptor;
} PR_TGAHEADER;
PR_TGAHEADER tga;



void DumpScreenshot (void)
/* Saves a TGA screenshot.  Shots are automatically numbered */
{
block pic;
FILE *out;
unsigned short *temp;
PR_UWORD rgb;
PR_DWORD l;
PR_DWORD r, g, b;
char outfile[80];
PR_DWORD number;


  number = 1;
  for (;;)
   {
    sprintf (outfile, "screen%i.tga", number);
    out = fopen (outfile, "rb");
    if (out == NULL)
      break;
    number++;
    fclose (out);
   }

  pic = PRGFX_NewBlock (0, 0, 639, 479);
  temp = (unsigned short *)pic;

  memset ((char *)&tga, 0, sizeof (PR_TGAHEADER));
  tga.descriptor = 0x20;
  tga.width = 640;
  tga.depth = 480;
  tga.idlength = 0;
  tga.imagetype = 2;
  tga.bits = 24;

  sprintf (outfile, "screen%i.tga", number);
  out = fopen (outfile, "wb");
  fwrite (&tga, sizeof (PR_TGAHEADER), 1, out);

  for (l = 0; l < 640*480; l++)
    {
     rgb = *temp++;

     r = (rgb >> 11);
     g = (rgb - (r << 11)) >> 5;
     b = (rgb - (r << 11) - (g << 5));

     fputc (b << 3, out);
     fputc (g << 2, out);
     fputc (r << 3, out);
    }

  fclose (out);

  free (pic);
}



void LoadINI (void)
/* Loads the edit parameters from the INI file.
   Assumes a specific order for the contents of the file.
 */
{
FILE *ini;
char temp[80];
char buf[81];

  PRGUI_GoStartPath ();

  ini = fopen ("scnedit.ini", "rt");
  if (ini == NULL)
    PR_FatalError ("Cannot find scnedit.ini!", "scnedit");

  fgets (buf, 80, ini);
  sscanf (buf, "%s %i", temp, &MaxObjects);

  fgets (buf, 80, ini);
  sscanf (buf, "%s %i", temp, &MaxEntities);
  
  fgets (buf, 80, ini);
  sscanf (buf, "%s %f", temp, &MOVEMENT_MULT);

  fgets (buf, 80, ini);
  sscanf (buf, "%s %f", temp, &FOG_START);

  fgets (buf, 80, ini);
  sscanf (buf, "%s %f", temp, &FOG_END);

  fclose (ini);
}



void nokey (PR_DWORD keynum)
/* Waits for a specific key to be released */
{
PR_DWORD dummy = 0;

 while (kbdon[keynum])
   {
    #ifdef WIN32
      UpdateMessages ();
    #endif
    dummy++;
   }
}



PR_DWORD FindObject (char *filename)
/* -----------------------------------------------------------------------
   Function:   FindObject
   Purpose:    Finds the object number given its filename
   Parameters: filename - Filename of the object
   Return:     OBJECT_NOT_FOUND if the file is not in the ObjectList array
               or object number
   ----------------------------------------------------------------------- */
{
PR_DWORD i;
char *name;

  if (filename == NULL)
    return (OBJECT_NOT_FOUND);
  strupr (filename);
  
  if (MaxObjects == 0)
    return (OBJECT_NOT_FOUND);

  for (i = 0; i < MaxObjects; i++)
    if (ObjectList[i].name != NULL)
      {
       name = strdup (ObjectList[i].name);
       strupr (name);
    
       if (strcmp (name, filename) == 0)
         {
          free (name);
          return (i);
         }
       free (name);
     }
  return (OBJECT_NOT_FOUND);
}


PR_DWORD LoadObject (char *filename)
{
PR_DWORD i;
PR_DWORD found;

  found = -1;

  /* Find an empty position */
  for (i = 0; i < MaxObjects; i++)
    if (ObjectList[i].name == NULL)
      {
       found = i;
       break;
      }

  if (found == -1)
    return -1;


  ObjectList[found].obj = PR_LoadPRO (filename, LOAD_NORMAL);
  if (ObjectList[found].obj != NULL)
    {
     ObjectList[found].name = strdup (filename);
     ObjectList[found].lastscale.x = 1.0f;
     ObjectList[found].lastscale.y = 1.0f;
     ObjectList[found].lastscale.z = 1.0f;
     PR_MatrixIdentity (ObjectList[found].lastrot);

     return found;
    }

  return -1;
}



void AllocObjects (void)
/* -----------------------------------------------------------------------
   Function:   AllocObjects
   Purpose:    Allocates room for a list of objects
   Parameters: maxobj - Number of objects to allocate space for
   Return:     None
   ----------------------------------------------------------------------- */
{
PR_DWORD i;

  ObjectList = (ObjectType *)malloc (sizeof (ObjectType) * MaxObjects);

  for (i = 0; i < MaxObjects; i++)
    {
     ObjectList[i].obj = NULL;
     ObjectList[i].name = NULL;
    }
}



void AllocEntities (void)
/* -----------------------------------------------------------------------
   Function:   AllocEntities
   Purpose:    Allocates room for a list of objects
   Parameters: maxobj - Number of objects to allocate space for
   Return:     None
   ----------------------------------------------------------------------- */
{
PR_DWORD i;

  EntityList = (EntityType *)malloc (sizeof (EntityType) * MaxEntities);

  for (i = 0; i < MaxEntities; i++)
    {
     PR_MatrixIdentity (EntityList[i].rot_mat);
     EntityList[i].location.x = 0.0f;
     EntityList[i].location.y = 0.0f;
     EntityList[i].location.z = 0.0f;

     EntityList[i].scale.x = 1.0f;
     EntityList[i].scale.y = 1.0f;
     EntityList[i].scale.z = 1.0f;
     EntityList[i].active = 0;

     EntityList[i].ent = NULL;
     EntityList[i].name[0] = 0;
    }
}



void InitializeEntity (PR_DWORD entnum)
/* This is used to create the entity with the right settings */
{
  memcpy (EntityList[entnum].ent->orientation.rot_mat,
          EntityList[entnum].rot_mat, sizeof (PR_MATRIX));
  PR_PositionEntity (EntityList[entnum].ent,
                     EntityList[entnum].location.x,
                     EntityList[entnum].location.y,
                     EntityList[entnum].location.z);
  PR_ScaleEntityAbs (EntityList[entnum].ent,
                     EntityList[entnum].scale.x,
                     EntityList[entnum].scale.y,
                     EntityList[entnum].scale.z);
}





void FindMaxEntity (void)
/* Determines the index of the last entity used */
{
PR_DWORD i;

  TopEntity = 0;
  for (i = 0; i < MaxEntities; i++)
     if (EntityList[i].active)
       TopEntity = i;
  TopEntity++;
}



void NewEntity (void)
{
PR_DWORD i;

  if (EntityList[entity_number].active)
    return;

  /* Set the scale */
  EntityList[entity_number].scale.x = ObjectList[object_number].lastscale.x;
  EntityList[entity_number].scale.y = ObjectList[object_number].lastscale.y;
  EntityList[entity_number].scale.z = ObjectList[object_number].lastscale.z;

  /* Set the rotation */
  memcpy (EntityList[entity_number].rot_mat,
          ObjectList[object_number].lastrot, sizeof (PR_MATRIX));

  /* Set up misc */
  strcpy (EntityList[entity_number].name, ObjectList[object_number].name);

  /* Create the entity and initialize it with the current settings */
  EntityList[entity_number].ent = PR_CreateEntity (ObjectList[object_number].obj, "Ent");
  InitializeEntity (entity_number);

  EntityList[entity_number].active = 1;

  /* Find the topmost entity in the array */
  TopEntity = 0;
  for (i = 0; i < MaxEntities; i++)
    {
     if (EntityList[i].active)
       TopEntity = i;
    }
  TopEntity++;
}


void SwitchObject (void)
{
  if (EntityList[entity_number].ent != NULL)
    PR_FreeEntity (EntityList[entity_number].ent);

  strcpy (EntityList[entity_number].name, ObjectList[object_number].name);
  EntityList[entity_number].ent = PR_CreateEntity (ObjectList[object_number].obj, "Ent");
  InitializeEntity (entity_number);
}



void ComputeDirections (void)
/* Computes the forward and right direction vectors for moving the entities around */
{
  PR_CameraDirection (camera);
  ForwardVec.x = camera->direction.x;
  ForwardVec.y = camera->direction.y;
  ForwardVec.z = camera->direction.z;
  PR_VecCrossProduct(RightVec, ForwardVec, UpVec);
  ForwardVec.y = 0;
  RightVec.y = 0;
  PR_Normalize (&ForwardVec);
  PR_Normalize (&RightVec);
}



void InitializeAllObjects (void)
{
PR_DWORD entnum;

  for (entnum = 0; entnum <= TopEntity; entnum++)
    {
     /* Create the entity and initialize it with the current settings */
     object_number = FindObject (EntityList[entnum].name);
     if (object_number != OBJECT_NOT_FOUND)
          {
           EntityList[entnum].ent = PR_CreateEntity (ObjectList[object_number].obj, "Ent");
           InitializeEntity (entnum);
           EntityList[entnum].active = 1;
          }
     else
       EntityList[entnum].active = 0;
    }

  object_number = 0;
}


void LoadScene (char *filename)
/* Load the object data from a file.
   The camera position is also loaded. */
 {
PR_DWORD numobjects;
FILE *in;

  PRGUI_GoUserPath ();

  in = fopen (filename, "rb");
  if (in == NULL)
    return;

  fread (&numobjects, 4, 1, in);

  fread (EntityList, sizeof (EntityType), numobjects, in);

  fread (&camera->source.x, 4, 1, in);
  fread (&camera->source.y, 4, 1, in);
  fread (&camera->source.z, 4, 1, in);
  fread (&camera->rotation.x, 4, 1, in);
  fread (&camera->rotation.y, 4, 1, in);
  fread (&camera->rotation.z, 4, 1, in);
  fclose (in);

  ComputeDirections ();

  TopEntity = numobjects-1;
  InitializeAllObjects ();
}







void SaveScene (char *filename)
/* Save the scene file */
{
PR_DWORD numentities;
FILE *out;

  PRGUI_GoUserPath ();

  FindMaxEntity ();
  numentities = TopEntity + 1;

  out = fopen (filename, "wb");

  fwrite (&numentities, 4, 1, out);
  fwrite (EntityList, sizeof (EntityType), numentities, out);

  fwrite (&camera->source.x, 4, 1, out);
  fwrite (&camera->source.y, 4, 1, out);
  fwrite (&camera->source.z, 4, 1, out);
  fwrite (&camera->rotation.x, 4, 1, out);
  fwrite (&camera->rotation.y, 4, 1, out);
  fwrite (&camera->rotation.z, 4, 1, out);
  fclose (out);
}


void DisplayString (PR_DWORD x, PR_DWORD y, char *fmt, ...)
/* Displays a string in the status bar along the bottom of the screen */
{
va_list  argptr;                     /* Argument list pointer*/
char str[251];                       /* Buffer to build string into*/
PR_DWORD i;

  va_start (argptr, fmt);              /* Initialize va_ functions*/

  vsprintf (str, fmt, argptr);         /* prints string to buffer*/

  PRGFX_SetTextForeground (WHITE);
  PRGFX_SetTextBackground (DARK_GREY);
  PRGFX_SetTextTransparent (TEXTFGBG);
  PRGFX_SetColor (DARK_GREY);

  for (i = 0; i < PR_OutputDevice.pages; i++)
    {
     PR_OpenScreen (i);

     PRGFX_Bar (0, 471,  479, 479);
     PRGFX_OutTextXY (x, y, gui_font, str);
     /* Send string in graphics mode */
    }

  va_end (argptr);                     /* Close va_ functions*/
}



void SearchForObjects (void)
{
#ifdef __WATCOMC__
struct find_t fileinfo;
#else
struct _finddata_t fileinfo;
long fhandle;
#endif

unsigned rc;

  #ifdef __WATCOMC__
    rc = _dos_findfirst("*.PRO", _A_NORMAL, &fileinfo);
  #else
    fhandle = _findfirst("*.PRO", &fileinfo);
    if (fhandle == -1)
      rc = -1;
    #endif

  while (rc == 0)
    {
     // load fileinfo.name
     DisplayString (3, 471, fileinfo.name);
     LoadObject (fileinfo.name);
     ObjectsLoaded++;

     #ifdef __WATCOMC__
       rc = _dos_findnext (&fileinfo);
     #else
       rc = _findnext (fhandle, &fileinfo);
     #endif
    }


  if (ObjectsLoaded == 0)
    PR_FatalError ("Didn't find any .PRO files to build a scene with!", "scnedit");
}



void RenderEntities (void)
/* Displays the entities */
{
PR_DWORD i;

  for (i = 0; i < TopEntity; i++)
    {
     if (EntityList[i].active)
       {
        PR_TransformEntity (EntityList[i].ent);

        if ((flashflag) && (flashswitch) && (i == entity_number))
          continue;

        PR_RenderEntity (EntityList[i].ent);
       }
    }
}



void ScaleEntity (PR_REAL x, PR_REAL y, PR_REAL z)
{
  x = 1.0f + x / 100.0f;
  y = 1.0f + y / 100.0f;
  z = 1.0f + z / 100.0f;

  PR_ScaleEntity (EntityList[entity_number].ent, x, y, z);
 
  EntityList[entity_number].scale.x = EntityList[entity_number].ent->orientation.scale.x;
  EntityList[entity_number].scale.y = EntityList[entity_number].ent->orientation.scale.y;
  EntityList[entity_number].scale.z = EntityList[entity_number].ent->orientation.scale.z;
}




void DisplayButtons (void)
/* Show the check boxes  */
{
PR_DWORD i;

  PRGUI_HideMouse ();
  PR_DepthBufferFunction (PR_CMP_ALWAYS);

  for (i = 0; i < PR_OutputDevice.pages; i++)
    {
     PR_OpenScreen (i);
     PR_NewFrame ();

     if (EntityList[entity_number].active)
       {
        PRGFX_ResizeTexture (488, 216, 488+23, 216+17, unchecktex, NORMAL);
        PRGFX_ResizeTexture (488, 235, 488+23, 235+17, checktex, NORMAL);
       }
     else
       {
        PRGFX_ResizeTexture (488, 216, 488+23, 216+17, checktex, NORMAL);
        PRGFX_ResizeTexture (488, 235, 488+23, 235+17, unchecktex, NORMAL);
       }

     if (current_mode == MODE_LOCATION)
       PRGFX_ResizeTexture (488, 268, 488+23, 268+17, checktex, NORMAL);
     else
       PRGFX_ResizeTexture (488, 268, 488+23, 268+17, unchecktex, NORMAL);

     if (current_mode == MODE_ROTATION)
       PRGFX_ResizeTexture (488, 286, 488+23, 286+17, checktex, NORMAL);
     else
       PRGFX_ResizeTexture (488, 286, 488+23, 286+17, unchecktex, NORMAL);

     if (current_mode == MODE_SCALE)
       PRGFX_ResizeTexture (488, 304, 488+23, 304+17, checktex, NORMAL);
     else
       PRGFX_ResizeTexture (488, 304, 488+23, 304+17, unchecktex, NORMAL);
     PR_RenderFrame ();
    }

  PR_DepthBufferFunction (PR_CMP_LEQUAL);
  PRGUI_ShowMouse ();
}



void UpdateEntityNumber (void)
/* Display the current entity number */
{
PR_DWORD i;

  PRGFX_SetTextForeground (TEXTCOL);
  PRGFX_SetTextTransparent (TEXTFG);
  PRGFX_Clip (0, 0, 639, 479);
  PRGFX_SetColor (PRGFX_MakeColor (1, 17, 23));

  for (i = 0; i < PR_OutputDevice.pages; i++)
    {
     PR_OpenScreen (i);
     PRGFX_Bar (570, 135, 610, 145);
     PRGUI_printf (570, 135, "%i", entity_number);
    }
}


void UpdateObjectNumber (void)
/* Display the current object number */
{
PR_DWORD i;
char temp[14];

  PRGFX_SetTextForeground (TEXTCOL);
  PRGFX_SetTextTransparent (TEXTFG);
  PRGFX_Clip (0, 0, 639, 479);
  PRGFX_SetColor (PRGFX_MakeColor (1, 17, 23));

  strcpy (temp, ObjectList[object_number].name);
  temp[strlen(temp)-4] = 0;  /* Remove .pro extension */

  for (i = 0; i < PR_OutputDevice.pages; i++)
    {
     PR_OpenScreen (i);
     PRGFX_Bar (570, 184, 637, 194);
     PRGUI_printf (570, 184, "%s", temp);
    }
}





void InitMainMenu (void)
/* Draw the menu, plus misc setup */
{
PR_DWORD i;

  PRGUI_GoStartPath ();
  setlib ("scnedit.gui");


  gui_font = wloadfont ("system.wfn");

  unchecktex = PR_LoadTexture("uncheck.pcx");
  checktex   = PR_LoadTexture("check.pcx");

  menu1 = wloadpcx ("menu1.pcx", menu_pal);

  setlib (NULL);

  PRGUI_HideMouse ();

  for (i = 0; i < PR_OutputDevice.pages; i++)
    {
     PR_OpenScreen (i);

     PRGFX_SetColor (GUI_BLACK);
     PRGFX_ClearScreen ();
     
     PR_BeginScreen ();
     PRGFX_PutBlock8bit (480, 0, menu1, menu_pal, 0);
     PR_EndScreen ();
    }

  entity_number = 0;
  object_number = FindObject (EntityList[0].name);
  if (object_number < 0)
    object_number = 0;


  UpdateEntityNumber ();
  UpdateObjectNumber ();

  DisplayButtons ();

  PRGUI_ShowMouse ();

  wfreeblock (menu1);

  PRGUI_ShowMouse ();

  DisplayString (3, 471, "Loading Scene");
}


/* ---------------------------------------------------------------------- */
/* Make one light which will follow the camera */
/* ---------------------------------------------------------------------- */
void InitializeLights (void)
{
  /* Initialize the lights */
  PR_AllocLights (&userlights, 1);      /* User lights */
  PR_AllocLights (&scenelights, 1);     /* Master scene light list */

  PR_SetLightPosition (&userlights, 0, 0, 0, 10000);
  /* Doesn't matter because we set it to the camera location every frame */

  PR_SetLightOn (&userlights, 0);
  PR_SetLightType (&userlights, 0, DIRECTIONAL_LIGHT);
  PR_SetLightStrength (&userlights, 0, 1.0);
  PR_SetLightColor (&userlights, 0, 1.0, 1.0, 1.0);

  userlights.NumLights = 1;     /* This sets how many lights are actually used */
}


void Init3D (void)
/* Initialize the 3D engine, camera, viewports, etc */
{
  PRGUI_HideMouse ();

  UpVec.x = 0;
  UpVec.y = 1;
  UpVec.z = 0;

  PRGUI_GoUserPath ();

  /* Open the 3D viewport */
  PR_OpenViewport (&viewport, 0, 0, DISPWIDTH-1, DISPHEIGHT-1, VIEW_PLAIN);

  PR_SetViewport (&viewport);

  camera = PR_AllocCamera ();
  PR_InitializeCamera (camera);
  PR_PositionCameraSource (camera, 0, 0, 400);
  camera->rotation.y = 0;
  camera->aspect_ratio = 1.0;
  PR_SetCameraMode (camera, CAMFLAG_ANGLE_BASED);
  PR_SetActiveCamera (camera);
  ComputeDirections ();

  PR_SetInputDevice (INPUT_MOUSE);
  PR_SetInputModel (MODEL_INSPECT);
  PR_SetInputEntity (NO_ENTITY, NO_SEGMENT);
  PR_SetInputCamera (camera);

  PR_AmbientRed   = 0;
  PR_AmbientGreen = 0;
  PR_AmbientBlue  = 0;

  InitializeLights ();

  PRGFX_Clip (0, 0, 639, 479);
  PRGUI_ShowMouse ();
}


extern PR_DWORD last_method;

void Display3D (void)
/* Update the 3D window */
{
  flashflag = !flashflag;

  PR_SetActiveCamera (camera);

  PR_OpenScreen (PR_BACKBUFFER);
  PRGFX_Clip (active_viewport.topx,
              active_viewport.topy,
              active_viewport.bottomx,
              active_viewport.bottomy);

  PRGFX_SetColor (BLACK);
  PR_ClearViewport (&viewport);

  PR_NewFrame ();                         /* Begin a new frame */

  if (use_background)
    {
     PR_SetConstantZ (64000);
     PRGFX_ResizeTexture (0, 0, 639, 479, PR_FindTexture ("back.pcx"), 0);
     PR_SetConstantZ (1);
    }

  PR_SetLightPosition (&userlights, 0,
                        PR_CurrentCamera->source.x,
                        PR_CurrentCamera->source.y,
                        PR_CurrentCamera->source.z);
  PR_TransformLights (&userlights);

  RenderEntities ();
 
  PR_RenderFrame ();

  PRGFX_Clip (0, 0, 639, 479);

  PR_Flip (1);
}




void DisplayHelp (void)
/* Show the help screen */
{
  PRGFX_SetTextForeground (WHITE);
  PRGFX_SetTextTransparent (TEXTFG);

  PRGUI_printf (0, 20, "Scene Edit 1.0");
  PRGUI_printf (0, 30, "Copyright 1998 Egerter Software");
  PRGUI_printf (0, 40, "Visit http://www.egerter.com");

  PRGUI_printf (0, 60, "Hold down CTRL and slide mouse up and down to dolly the");
  PRGUI_printf (0, 70, "camera.");
  PRGUI_printf (0, 90, "Hold down ALT and move the mouse to tilt camera.");
  PRGUI_printf (0, 110, "Hold the left or right mouse button and modify the");
  PRGUI_printf (0, 120, "current entity while in the 3D display area.");

  PRGUI_printf (0, 140, "Current entity will flash while CTRL or ALT is pressed.");

  PRGUI_printf (0, 160, "HOME moves the camera to the origin.");
  PRGUI_printf (0, 170, "ENTER moves the camera to the current entity.");
  PRGUI_printf (0, 180, "SPACE moves the current entity to the camera.");
  PRGUI_printf (0, 190, "PGUP goes to previous entity.");
  PRGUI_printf (0, 200, "PGDN goes to next entity.");
  PRGUI_printf (0, 210, "+ goes to previous object.");
  PRGUI_printf (0, 220, "- goes to next object.");
  PRGUI_printf (0, 230, "X resets the location, rotation, or scale.");
  PRGUI_printf (0, 240, "Left shift while rotating will rotate about y axis only.");
  PRGUI_printf (0, 250, "Left shift while scaling will scale all axis");
  PRGUI_printf (0, 260, "ESC quits.");

  nokey (KEY_F1);
  Display3D ();
}




void MainLoop (void)
{
PR_DWORD quit = 0;
PR_REAL dist;
PR_REAL tempx, tempy, tempz;

  PRGUI_HideMouse ();
 
  Display3D ();         /* Transform the entity once to generate the transformed vertices */
  Display3D ();         /* Display the results */
  PRGUI_ShowMouse ();

  DisplayButtons ();

  while ((!quit) && (!kbdon[KEY_ESC]))
   {
    #ifdef WIN32
      UpdateMessages ();
    #endif

    #if defined (MSDD) || defined (WTDD)
      if (PR_LostSurface)
        PR_RestoreAll ();
    #endif


    /* Rotate Camera */    
    if (kbdon[KEY_ALT])
      {
       PRGUI_HideMouse ();
       mouse_savex = mouse.mx;
       mouse_savey = mouse.my;
       msetxy (160, 100);
       while (kbdon[KEY_ALT])
         {
          #ifdef WIN32
            UpdateMessages ();
          #endif
          PR_ReadInput ();
          msetxy (160, 100);

          flashswitch = 1;
          Display3D ();
         }

       if (flashflag)   /* Make sure entity is on */
         Display3D ();
       msetxy (mouse_savex, mouse_savey);
       PRGUI_ShowMouse ();

       ComputeDirections ();
      }


    /* Dolly Camera */
    if (kbdon[KEY_CTRL])
      {
       PRGUI_HideMouse ();
       mouse_savex = mouse.mx;
       mouse_savey = mouse.my;
       msetxy (160, 100);
       while (kbdon[KEY_CTRL])
         {
          #ifdef WIN32
            UpdateMessages ();
          #endif
          PR_DollyCamera (camera, (100 - mouse.my) * MOVEMENT_MULT);
          msetxy (160, 100);

          flashswitch = 1;
          Display3D ();
         }

       if (flashflag)   /* Make sure entity is on */
         Display3D ();
       msetxy (mouse_savex, mouse_savey);
       PRGUI_ShowMouse ();
      }

    if ((PRGUI_HitButton (488, 119, 515, 136)) || (kbdon[KEY_PGUP]))
    /* Entity up */
      {
       if (entity_number > 0)
         entity_number--;

       object_number = FindObject (EntityList[entity_number].name);
       if (object_number < 0)
         object_number = 0;

       UpdateEntityNumber ();
       UpdateObjectNumber ();
       DisplayButtons ();
       noclick ();
       nokey (KEY_PGUP);
      }

    if ((PRGUI_HitButton (494, 138, 509, 153)) || (kbdon[KEY_PGDN]))
    /* Entity down */
      {
       if (entity_number < MaxEntities-1)
         entity_number++;
        
       object_number = FindObject (EntityList[entity_number].name);
       if (object_number < 0)
         object_number = 0;

       UpdateEntityNumber ();
       UpdateObjectNumber ();
       DisplayButtons ();
       noclick ();
       nokey (KEY_PGDN);
      }

    if ((PRGUI_HitButton (488, 168, 515, 185)) || (kbdon[KEY_GREY_MINUS]))
    /* Object up */
      {
       if (object_number > 0)
         object_number--;

       SwitchObject ();
       UpdateEntityNumber ();
       UpdateObjectNumber ();
       DisplayButtons ();
       Display3D ();
       if (flashflag)   /* Make sure entity is on */
         Display3D ();

       noclick ();
       nokey (KEY_PGUP);
      }

    if ((PRGUI_HitButton (494, 186, 509, 186+17)) || (kbdon[KEY_GREY_PLUS]))
    /* Object down */
      {
       if (object_number < ObjectsLoaded-1)
         object_number++;

       SwitchObject ();
       UpdateEntityNumber ();
       UpdateObjectNumber ();
       DisplayButtons ();
       Display3D ();
       if (flashflag)   /* Make sure entity is on */
         Display3D ();

       noclick ();
       nokey (KEY_PGDN);
      }


    if (PRGUI_HitButton (488, 216, 488+23, 216+17))
    /* Off */
      {
       EntityList[entity_number].active = 0;

       UpdateEntityNumber ();
       UpdateObjectNumber ();
       DisplayButtons ();

       Display3D ();

       noclick ();
      }

    if (PRGUI_HitButton (488, 235, 488+23, 235+17))
    /* On */
      {
       if (!EntityList[entity_number].active)
         {
          EntityList[entity_number].location.x = camera->source.x - camera->direction.x * MOVEMENT_MULT * 35;
          EntityList[entity_number].location.y = camera->source.y - camera->direction.y * MOVEMENT_MULT * 35;
          EntityList[entity_number].location.z = camera->source.z - camera->direction.z * MOVEMENT_MULT * 35;
          NewEntity ();
         }

       UpdateEntityNumber ();
       UpdateObjectNumber ();
       DisplayButtons ();
       Display3D ();

       if (flashflag)   /* Make sure entity is on */
         Display3D ();
       noclick ();
      }


    if (PRGUI_HitButton (488, 268, 488+23, 268+17))
      {
       current_mode = MODE_LOCATION;

       UpdateEntityNumber ();
       UpdateObjectNumber ();
       DisplayButtons ();
       Display3D ();

       noclick ();
      }

    if (PRGUI_HitButton (488, 286, 488+23, 286+17))
      {
       current_mode = MODE_ROTATION;

       UpdateEntityNumber ();
       UpdateObjectNumber ();
       DisplayButtons ();
       Display3D ();

       noclick ();
      }

    if (PRGUI_HitButton (488, 304, 488+23, 304+17))
      {
       current_mode = MODE_SCALE;

       UpdateEntityNumber ();
       UpdateObjectNumber ();
       DisplayButtons ();
       Display3D ();

       noclick ();
      }





    if (PRGUI_HitButton (483, 386, 636, 411))
    /* Save scene */
      {
       DisplayString (3, 471, "Saving Scene File");
       SaveScene (scene_name);
       noclick ();
       DisplayString (3, 471, " ");
      }

    if (PRGUI_HitButton (483, 447, 636, 472))
      quit = 1;

    if ((PRGUI_HitButton (0, 0, 479, 469)) && (EntityList[entity_number].active))
    /* 3D Display */
      {
       PRGUI_HideMouse ();
       msetxy (160, 100);
       while (mouse.but)
         {
          #ifdef WIN32
            UpdateMessages ();
          #endif

          if ((mouse.my != 100) | (mouse.mx != 160))
            {
             if (current_mode == MODE_LOCATION)
               {
                if (mouse.but == 1)
                  {
                   dist = (mouse.my - 100) * MOVEMENT_MULT;
                   PR_VecScalarMultiply(TempVec, dist, ForwardVec);
                   PR_VecAdd(EntityList[entity_number].location, EntityList[entity_number].location, TempVec);

                   dist = (mouse.mx - 160) * MOVEMENT_MULT;
                   PR_VecScalarMultiply(TempVec, dist, RightVec);
                   TempVec.y = 0;
                   PR_VecAdd(EntityList[entity_number].location, EntityList[entity_number].location, TempVec);
                  }
                else if (mouse.but == 2)
                   EntityList[entity_number].location.y -= (mouse.my - 100) * MOVEMENT_MULT;

                PR_PositionEntity (EntityList[entity_number].ent,
                                   EntityList[entity_number].location.x,
                                   EntityList[entity_number].location.y,
                                   EntityList[entity_number].location.z);
               }
             else if (current_mode == MODE_ROTATION)
               {
                tempx = 0;
                tempy = 0;
                tempz = 0;

                if (mouse.but == 1)
                  {
                   tempy = mouse.mx - 160;
                   tempz = mouse.my - 100;
                  }
                else if (mouse.but == 2)
                  tempx = mouse.mx - 160;

                if (kbdon[KEY_LSHIFT])
                PR_RotateEntity (EntityList[entity_number].ent,
                                 0, tempy, 0);
                else
                 PR_RotateEntity (EntityList[entity_number].ent,
                                 tempx, tempy, tempz);

                memcpy (EntityList[entity_number].rot_mat,
                        EntityList[entity_number].ent->orientation.rot_mat, sizeof (PR_MATRIX));
                memcpy (ObjectList[object_number].lastrot,
                        EntityList[entity_number].rot_mat, sizeof (PR_MATRIX));
               }
             else if (current_mode == MODE_SCALE)
               {
                tempx = 0;
                tempy = 0;
                tempz = 0;

                if (mouse.but == 1)
                  {
                   tempx = mouse.mx - 160;
                   tempz = mouse.my - 100;
                  }
                else if (mouse.but == 2)
                  tempy = 100 - mouse.my;

                if (kbdon[KEY_LSHIFT])
                  ScaleEntity (tempx, tempx, tempx);
                else
                  ScaleEntity (tempx, tempy, tempz);
               }

             flashswitch = 0;
             msetxy (160, 100);
             Display3D ();
             DisplayString (3, 471, "X: %7.2f  Y: %7.2f  Z: %7.2f", EntityList[entity_number].location.x, EntityList[entity_number].location.y, EntityList[entity_number].location.z);
            }
         }

       PRGUI_ShowMouse ();
      }



    /* Extra keyboard controls */
    if (kbdon[KEY_S])
      DumpScreenshot ();

    if (kbdon[KEY_F1])
      DisplayHelp ();

    if (kbdon[KEY_HOME])        /* Center camera */
      {
       PR_PositionCameraSource (camera, 0, 0, 0);
       Display3D ();
      }

    if (kbdon[KEY_SPACE])        /* Move entity to camera */
      {
       EntityList[entity_number].location.x = camera->source.x - camera->direction.x * MOVEMENT_MULT * 35;
       EntityList[entity_number].location.y = camera->source.y - camera->direction.y * MOVEMENT_MULT * 35;
       EntityList[entity_number].location.z = camera->source.z - camera->direction.z * MOVEMENT_MULT * 35;
       PR_PositionEntity (EntityList[entity_number].ent,
                          EntityList[entity_number].location.x,
                          EntityList[entity_number].location.y,
                          EntityList[entity_number].location.z);
       Display3D ();
       if (flashflag)   /* Make sure entity is on */
         Display3D ();
      }

    if (kbdon[KEY_ENTER])        /* Move camera to entity */
      {
       camera->source.x = EntityList[entity_number].location.x + camera->direction.x * MOVEMENT_MULT * 35;
       camera->source.y = EntityList[entity_number].location.y + camera->direction.y * MOVEMENT_MULT * 35;
       camera->source.z = EntityList[entity_number].location.z + camera->direction.z * MOVEMENT_MULT * 35;
       Display3D ();
       if (flashflag)   /* Make sure entity is on */
         Display3D ();
      }



    if (kbdon[KEY_X])        /* Reset */
      {
       if (current_mode == MODE_LOCATION)
         {
          EntityList[entity_number].location.x = 0.0f;
          EntityList[entity_number].location.y = 0.0f;
          EntityList[entity_number].location.z = 0.0f;
          PR_PositionEntity (EntityList[entity_number].ent, 0.0f, 0.0f, 0.0f);
         }
       else if (current_mode == MODE_ROTATION)
         {
          PR_RotateEntityAbs (EntityList[entity_number].ent, 0.0f, 0.0f, 0.0f);
          memcpy (EntityList[entity_number].rot_mat,
                  EntityList[entity_number].ent->orientation.rot_mat, sizeof (PR_MATRIX));
          memcpy (ObjectList[object_number].lastrot,
                  EntityList[entity_number].rot_mat, sizeof (PR_MATRIX));
         }
       else if (current_mode == MODE_SCALE)
         {
          EntityList[entity_number].scale.x = 1.0f;
          EntityList[entity_number].scale.y = 1.0f;
          EntityList[entity_number].scale.z = 1.0f;
          PR_ScaleEntityAbs (EntityList[entity_number].ent, 1.0f, 1.0f, 1.0f);
         }

       Display3D ();
       if (flashflag)   /* Make sure entity is on */
         Display3D ();
      }

    PRGUI_DrawMouse ();
   }

  PRGUI_HideMouse ();
  noclick ();
}


void CheckForMissingTextures (void)
{
PR_DWORD i;

  for (i = 0; i < PR_NumTextures; i++)
    {
     if (PR_WorldTextures[i].filename != NULL)
       {
        if (PR_WorldTextures[i].width <= 0)
          PR_FatalError ("Cannot find texture", PR_WorldTextures[i].filename);
       }
    }
}

void main (int argc, char *argv[])
{
  PRGUI_InitPath (argv[0]);

  LoadINI ();

  if (argc < 2)
    {
     PR_FatalError (
             "scnedit 1.0\n"
             "Copyright 1998 Egerter Software\n\n"
             "Usage: \n"
             "scnedit scene.scn\n", "scnedit");
    }


  strcpy (scene_name, argv[1]);

  ChooseDevice ();

  PR_Initialize (5000);

  if ((device == DEVICE_VGA) || (device == DEVICE_SVGA))
    {
     #ifndef WIN32
      wsetmode (3);                        /* Go back to text mode */
     #endif
     PR_FatalError ("This utility requires a 3D card", "SCNEDIT");
    }

  PRGUI_GoStartPath ();

  InitializeDevices ();

  PR_AllocMaterials (1024);
  PR_AllocShadeTables (32);
  PR_AllocTextures (1024);

  setlib ("guidata.prl");
 
  ChooseGUI ();

  setlib (NULL);


  if (PR_OutputDevice.pages == 1)
    {
     start_screen = PR_FRONTBUFFER;
     end_screen = PR_FRONTBUFFER;
    }
  else 
    {
     start_screen = PR_FRONTBUFFER;
     end_screen = PR_BACKBUFFER;
    }

  PRGUI_GoUserPath ();
  setlib (NULL);

  PR_Settings.LoadPalette = 1;
  PR_Settings.HardwareMipmaps = -1;

  PRGUI_InitTimer ();
  installkbd ();

  use_background = PR_LoadTexture ("back.pcx");
  if (PR_WorldTextures[use_background].width > 0)
    use_background = 1;
  else
    {
     free (PR_WorldTextures[use_background].filename);
     PR_WorldTextures[use_background].filename = NULL;
     use_background = 0;
    }

  AllocObjects ();
  AllocEntities ();

  BLACK = PRGFX_MakeColor (0,0,0);
  DARK_GREY = PRGFX_MakeColor (20,20,20);
  WHITE = PRGFX_MakeColor (63,63,63);
  TEXTCOL = PRGFX_MakeColor (63,63,63);

  SearchForObjects ();

  CheckForMissingTextures ();

  Init3D ();   /* requires this before, so camera isn't null */

  InitMainMenu ();
  LoadScene (scene_name);
  PR_SetFogRange (FOG_START, FOG_END);

  DisplayString (3, 471, "Ready... Hold F1 for help");

  MainLoop ();

  uninstallkbd ();
  PRGUI_DeinitTimer ();

  PRGUI_GoUserPath ();
}


